Package org.apache.groovy.parser.antlr4

## Class AstBuilder

- java.lang.Object
- - org.antlr.v4.runtime.tree.AbstractParseTreeVisitor<Result>
  - - org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>
    - - org.apache.groovy.parser.antlr4.AstBuilder

- All Implemented Interfaces:
    `org.antlr.v4.runtime.tree.ParseTreeVisitor<Object>`, `GroovyParserVisitor<Object>`

      public class AstBuilder
      extends GroovyParserBaseVisitor<Object>

  Builds the AST from the parse tree generated by Antlr4.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AstBuilder​(SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `BlockStatement` | `appendStatementsToBlockStatement​(BlockStatement bs, Statement... statements)` |
    `ModuleNode` | `buildAST()` |
    `Object` | `visit​(org.antlr.v4.runtime.tree.ParseTree tree)` | Visit tree safely, no NPE occurred when the tree is null.
    `BinaryExpression` | `visitAdditiveExprAlt​(GroovyParser.AdditiveExprAltContext ctx)` | Visit a parse tree produced by the `additiveExprAlt` labeled alternative in `GroovyParser.expression()`.
    `BinaryExpression` | `visitAndExprAlt​(GroovyParser.AndExprAltContext ctx)` | Visit a parse tree produced by the `andExprAlt` labeled alternative in `GroovyParser.expression()`.
    `ClassNode` | `visitAnnotatedQualifiedClassName​(GroovyParser.AnnotatedQualifiedClassNameContext ctx)` | Visit a parse tree produced by `GroovyParser.annotatedQualifiedClassName()`.
    `AnnotationNode` | `visitAnnotation​(GroovyParser.AnnotationContext ctx)` | Visit a parse tree produced by `GroovyParser.annotation()`.
    `String` | `visitAnnotationName​(GroovyParser.AnnotationNameContext ctx)` | Visit a parse tree produced by `GroovyParser.annotationName()`.
    `List<AnnotationNode>` | `visitAnnotationsOpt​(GroovyParser.AnnotationsOptContext ctx)` | Visit a parse tree produced by `GroovyParser.annotationsOpt()`.
    `InnerClassNode` | `visitAnonymousInnerClassDeclaration​(GroovyParser.AnonymousInnerClassDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.anonymousInnerClassDeclaration(int)`.
    `Expression` | `visitArguments​(GroovyParser.ArgumentsContext ctx)` | Visit a parse tree produced by `GroovyParser.arguments()`.
    `List<Expression>` | `visitArrayInitializer​(GroovyParser.ArrayInitializerContext ctx)` | Visit a parse tree produced by `GroovyParser.arrayInitializer()`.
    `AssertStatement` | `visitAssertStatement​(GroovyParser.AssertStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.assertStatement()`.
    `BinaryExpression` | `visitAssignmentExprAlt​(GroovyParser.AssignmentExprAltContext ctx)` | Visit a parse tree produced by the `assignmentExprAlt` labeled alternative in `GroovyParser.expression()`.
    `Statement` | `visitBlock​(GroovyParser.BlockContext ctx)` | Visit a parse tree produced by `GroovyParser.block()`.
    `Statement` | `visitBlockStatement​(GroovyParser.BlockStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.blockStatement()`.
    `BlockStatement` | `visitBlockStatements​(GroovyParser.BlockStatementsContext ctx)` | Visit a parse tree produced by `GroovyParser.blockStatements()`.
    `BlockStatement` | `visitBlockStatementsOpt​(GroovyParser.BlockStatementsOptContext ctx)` | Visit a parse tree produced by `GroovyParser.blockStatementsOpt()`.
    `ConstantExpression` | `visitBooleanLiteralAlt​(GroovyParser.BooleanLiteralAltContext ctx)` | Visit a parse tree produced by the `booleanLiteralAlt` labeled alternative in `GroovyParser.literal()`.
    `BreakStatement` | `visitBreakStatement​(GroovyParser.BreakStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.breakStatement()`.
    `VariableExpression` | `visitBuiltInType​(GroovyParser.BuiltInTypeContext ctx)` | Visit a parse tree produced by `GroovyParser.builtInType()`.
    `CastExpression` | `visitCastExprAlt​(GroovyParser.CastExprAltContext ctx)` | Visit a parse tree produced by the `castExprAlt` labeled alternative in `GroovyParser.castOperandExpression()`.
    `ClassNode` | `visitCastParExpression​(GroovyParser.CastParExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.castParExpression()`.
    `List<CatchStatement>` | `visitCatchClause​(GroovyParser.CatchClauseContext ctx)` | Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List
    `List<ClassNode>` | `visitCatchType​(GroovyParser.CatchTypeContext ctx)` | Visit a parse tree produced by `GroovyParser.catchType()`.
    `Void` | `visitClassBody​(GroovyParser.ClassBodyContext ctx)` | Visit a parse tree produced by `GroovyParser.classBody(int)`.
    `Void` | `visitClassBodyDeclaration​(GroovyParser.ClassBodyDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.classBodyDeclaration(int)`.
    `ClassNode` | `visitClassDeclaration​(GroovyParser.ClassDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.classDeclaration()`.
    `Tuple2<Parameter,​Expression>` | `visitClassicalForControl​(GroovyParser.ClassicalForControlContext ctx)` | Visit a parse tree produced by `GroovyParser.classicalForControl()`.
    `List<ModifierNode>` | `visitClassifiedModifiers​(GroovyParser.ClassifiedModifiersContext ctx)` | Visit a parse tree produced by `GroovyParser.classifiedModifiers(int)`.
    `String` | `visitClassName​(GroovyParser.ClassNameContext ctx)` | Visit a parse tree produced by `GroovyParser.className()`.
    `ModifierNode` | `visitClassOrInterfaceModifier​(GroovyParser.ClassOrInterfaceModifierContext ctx)` | Visit a parse tree produced by `GroovyParser.classOrInterfaceModifier()`.
    `List<ModifierNode>` | `visitClassOrInterfaceModifiers​(GroovyParser.ClassOrInterfaceModifiersContext ctx)` | Visit a parse tree produced by `GroovyParser.classOrInterfaceModifiers()`.
    `List<ModifierNode>` | `visitClassOrInterfaceModifiersOpt​(GroovyParser.ClassOrInterfaceModifiersOptContext ctx)` | Visit a parse tree produced by `GroovyParser.classOrInterfaceModifiersOpt()`.
    `ClassNode` | `visitClassOrInterfaceType​(GroovyParser.ClassOrInterfaceTypeContext ctx)` | Visit a parse tree produced by `GroovyParser.classOrInterfaceType()`.
    `ClosureExpression` | `visitClosure​(GroovyParser.ClosureContext ctx)` | Visit a parse tree produced by `GroovyParser.closure()`.
    `ClosureExpression` | `visitClosureOrLambdaExpression​(GroovyParser.ClosureOrLambdaExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.closureOrLambdaExpression()`.
    `Expression` | `visitCommandArgument​(GroovyParser.CommandArgumentContext ctx)` | Visit a parse tree produced by `GroovyParser.commandArgument()`.
    `ExpressionStatement` | `visitCommandExprAlt​(GroovyParser.CommandExprAltContext ctx)` | Visit a parse tree produced by the `commandExprAlt` labeled alternative in `GroovyParser.statementExpression()`.
    `Expression` | `visitCommandExpression​(GroovyParser.CommandExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.commandExpression()`.
    `ModuleNode` | `visitCompilationUnit​(GroovyParser.CompilationUnitContext ctx)` | Visit a parse tree produced by `GroovyParser.compilationUnit()`.
    `Expression` | `visitConditionalExprAlt​(GroovyParser.ConditionalExprAltContext ctx)` | Visit a parse tree produced by the `conditionalExprAlt` labeled alternative in `GroovyParser.expression()`.
    `Statement` | `visitConditionalStatement​(GroovyParser.ConditionalStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.conditionalStatement()`.
    `ContinueStatement` | `visitContinueStatement​(GroovyParser.ContinueStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.continueStatement()`.
    `ClassNode` | `visitCreatedName​(GroovyParser.CreatedNameContext ctx)` | Visit a parse tree produced by `GroovyParser.createdName()`.
    `Expression` | `visitCreator​(GroovyParser.CreatorContext ctx)` | Visit a parse tree produced by `GroovyParser.creator(int)`.
    `Tuple3<Expression,​List<AnnotationNode>,​org.antlr.v4.runtime.tree.TerminalNode>` | `visitDim​(GroovyParser.DimContext ctx)` | Visit a parse tree produced by `GroovyParser.dim()`.
    `DoWhileStatement` | `visitDoWhileStmtAlt​(GroovyParser.DoWhileStmtAltContext ctx)` | Visit a parse tree produced by the `doWhileStmtAlt` labeled alternative in `GroovyParser.loopStatement()`.
    `Expression` | `visitDynamicMemberName​(GroovyParser.DynamicMemberNameContext ctx)` | Visit a parse tree produced by `GroovyParser.dynamicMemberName()`.
    `Expression` | `visitElementValue​(GroovyParser.ElementValueContext ctx)` | Visit a parse tree produced by `GroovyParser.elementValue()`.
    `ListExpression` | `visitElementValueArrayInitializer​(GroovyParser.ElementValueArrayInitializerContext ctx)` | Visit a parse tree produced by `GroovyParser.elementValueArrayInitializer()`.
    `Tuple2<String,​Expression>` | `visitElementValuePair​(GroovyParser.ElementValuePairContext ctx)` | Visit a parse tree produced by `GroovyParser.elementValuePair()`.
    `Map<String,​Expression>` | `visitElementValuePairs​(GroovyParser.ElementValuePairsContext ctx)` | Visit a parse tree produced by `GroovyParser.elementValuePairs()`.
    `List<Tuple2<String,​Expression>>` | `visitElementValues​(GroovyParser.ElementValuesContext ctx)` | Visit a parse tree produced by `GroovyParser.elementValues()`.
    `List<List<AnnotationNode>>` | `visitEmptyDims​(GroovyParser.EmptyDimsContext ctx)` | Visit a parse tree produced by `GroovyParser.emptyDims()`.
    `List<List<AnnotationNode>>` | `visitEmptyDimsOpt​(GroovyParser.EmptyDimsOptContext ctx)` | Visit a parse tree produced by `GroovyParser.emptyDimsOpt()`.
    `Expression` | `visitEnhancedArgumentList​(GroovyParser.EnhancedArgumentListContext ctx)` | Visit a parse tree produced by `GroovyParser.enhancedArgumentList()`.
    `Expression` | `visitEnhancedArgumentListElement​(GroovyParser.EnhancedArgumentListElementContext ctx)` | Visit a parse tree produced by `GroovyParser.enhancedArgumentListElement()`.
    `Tuple2<Parameter,​Expression>` | `visitEnhancedForControl​(GroovyParser.EnhancedForControlContext ctx)` | Visit a parse tree produced by `GroovyParser.enhancedForControl()`.
    `Expression` | `visitEnhancedStatementExpression​(GroovyParser.EnhancedStatementExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.enhancedStatementExpression()`.
    `FieldNode` | `visitEnumConstant​(GroovyParser.EnumConstantContext ctx)` | Visit a parse tree produced by `GroovyParser.enumConstant()`.
    `List<FieldNode>` | `visitEnumConstants​(GroovyParser.EnumConstantsContext ctx)` | Visit a parse tree produced by `GroovyParser.enumConstants()`.
    `BinaryExpression` | `visitEqualityExprAlt​(GroovyParser.EqualityExprAltContext ctx)` | Visit a parse tree produced by the `equalityExprAlt` labeled alternative in `GroovyParser.expression()`.
    `BinaryExpression` | `visitExclusiveOrExprAlt​(GroovyParser.ExclusiveOrExprAltContext ctx)` | Visit a parse tree produced by the `exclusiveOrExprAlt` labeled alternative in `GroovyParser.expression()`.
    `Expression` | `visitExpressionInPar​(GroovyParser.ExpressionInParContext ctx)` | Visit a parse tree produced by `GroovyParser.expressionInPar()`.
    `List<Expression>` | `visitExpressionList​(GroovyParser.ExpressionListContext ctx)` | Visit a parse tree produced by `GroovyParser.expressionList(boolean)`.
    `Expression` | `visitExpressionListElement​(GroovyParser.ExpressionListElementContext ctx)` | Visit a parse tree produced by `GroovyParser.expressionListElement(boolean)`.
    `Void` | `visitFieldDeclaration​(GroovyParser.FieldDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.fieldDeclaration()`.
    `Statement` | `visitFinallyBlock​(GroovyParser.FinallyBlockContext ctx)` | Visit a parse tree produced by `GroovyParser.finallyBlock()`.
    `ConstantExpression` | `visitFloatingPointLiteralAlt​(GroovyParser.FloatingPointLiteralAltContext ctx)` | Visit a parse tree produced by the `floatingPointLiteralAlt` labeled alternative in `GroovyParser.literal()`.
    `Tuple2<Parameter,​Expression>` | `visitForControl​(GroovyParser.ForControlContext ctx)` | Visit a parse tree produced by `GroovyParser.forControl()`.
    `Expression` | `visitForInit​(GroovyParser.ForInitContext ctx)` | Visit a parse tree produced by `GroovyParser.forInit()`.
    `Parameter` | `visitFormalParameter​(GroovyParser.FormalParameterContext ctx)` | Visit a parse tree produced by `GroovyParser.formalParameter()`.
    `Parameter[]` | `visitFormalParameterList​(GroovyParser.FormalParameterListContext ctx)` | Visit a parse tree produced by `GroovyParser.formalParameterList()`.
    `Parameter[]` | `visitFormalParameters​(GroovyParser.FormalParametersContext ctx)` | Visit a parse tree produced by `GroovyParser.formalParameters()`.
    `ForStatement` | `visitForStmtAlt​(GroovyParser.ForStmtAltContext ctx)` | Visit a parse tree produced by the `forStmtAlt` labeled alternative in `GroovyParser.loopStatement()`.
    `Expression` | `visitForUpdate​(GroovyParser.ForUpdateContext ctx)` | Visit a parse tree produced by `GroovyParser.forUpdate()`.
    `GStringExpression` | `visitGstring​(GroovyParser.GstringContext ctx)` | Visit a parse tree produced by `GroovyParser.gstring()`.
    `Expression` | `visitGstringPath​(GroovyParser.GstringPathContext ctx)` | Visit a parse tree produced by `GroovyParser.gstringPath()`.
    `Expression` | `visitGstringValue​(GroovyParser.GstringValueContext ctx)` | Visit a parse tree produced by `GroovyParser.gstringValue()`.
    `String` | `visitIdentifier​(GroovyParser.IdentifierContext ctx)` | Visit a parse tree produced by `GroovyParser.identifier()`.
    `Expression` | `visitIdentifierPrmrAlt​(GroovyParser.IdentifierPrmrAltContext ctx)` | Visit a parse tree produced by the `identifierPrmrAlt` labeled alternative in `GroovyParser.primary()`.
    `IfStatement` | `visitIfElseStatement​(GroovyParser.IfElseStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.ifElseStatement()`.
    `ImportNode` | `visitImportDeclaration​(GroovyParser.ImportDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.importDeclaration()`.
    `BinaryExpression` | `visitInclusiveOrExprAlt​(GroovyParser.InclusiveOrExprAltContext ctx)` | Visit a parse tree produced by the `inclusiveOrExprAlt` labeled alternative in `GroovyParser.expression()`.
    `Tuple2<org.antlr.v4.runtime.Token,​Expression>` | `visitIndexPropertyArgs​(GroovyParser.IndexPropertyArgsContext ctx)` | Visit a parse tree produced by `GroovyParser.indexPropertyArgs()`.
    `ConstantExpression` | `visitIntegerLiteralAlt​(GroovyParser.IntegerLiteralAltContext ctx)` | Visit a parse tree produced by the `integerLiteralAlt` labeled alternative in `GroovyParser.literal()`.
    `ConstantExpression` | `visitKeywords​(GroovyParser.KeywordsContext ctx)` | Visit a parse tree produced by `GroovyParser.keywords()`.
    `Statement` | `visitLabeledStmtAlt​(GroovyParser.LabeledStmtAltContext ctx)` | Visit a parse tree produced by the `labeledStmtAlt` labeled alternative in `GroovyParser.statement()`.
    `Statement` | `visitLambdaBody​(GroovyParser.LambdaBodyContext ctx)` | Visit a parse tree produced by `GroovyParser.lambdaBody()`.
    `ListExpression` | `visitList​(GroovyParser.ListContext ctx)` | Visit a parse tree produced by `GroovyParser.list()`.
    `org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement` | `visitLocalVariableDeclaration​(GroovyParser.LocalVariableDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.localVariableDeclaration()`.
    `BinaryExpression` | `visitLogicalAndExprAlt​(GroovyParser.LogicalAndExprAltContext ctx)` | Visit a parse tree produced by the `logicalAndExprAlt` labeled alternative in `GroovyParser.expression()`.
    `BinaryExpression` | `visitLogicalOrExprAlt​(GroovyParser.LogicalOrExprAltContext ctx)` | Visit a parse tree produced by the `logicalOrExprAlt` labeled alternative in `GroovyParser.expression()`.
    `Statement` | `visitLoopStmtAlt​(GroovyParser.LoopStmtAltContext ctx)` | Visit a parse tree produced by the `loopStmtAlt` labeled alternative in `GroovyParser.statement()`.
    `MapExpression` | `visitMap​(GroovyParser.MapContext ctx)` | Visit a parse tree produced by `GroovyParser.map()`.
    `MapEntryExpression` | `visitMapEntry​(GroovyParser.MapEntryContext ctx)` | Visit a parse tree produced by `GroovyParser.mapEntry()`.
    `Expression` | `visitMapEntryLabel​(GroovyParser.MapEntryLabelContext ctx)` | Visit a parse tree produced by `GroovyParser.mapEntryLabel()`.
    `List<MapEntryExpression>` | `visitMapEntryList​(GroovyParser.MapEntryListContext ctx)` | Visit a parse tree produced by `GroovyParser.mapEntryList()`.
    `Void` | `visitMemberDeclaration​(GroovyParser.MemberDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.memberDeclaration(int)`.
    `Statement` | `visitMethodBody​(GroovyParser.MethodBodyContext ctx)` | Visit a parse tree produced by `GroovyParser.methodBody()`.
    `MethodNode` | `visitMethodDeclaration​(GroovyParser.MethodDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.methodDeclaration(int, int)`.
    `String` | `visitMethodName​(GroovyParser.MethodNameContext ctx)` | Visit a parse tree produced by `GroovyParser.methodName()`.
    `ModifierNode` | `visitModifier​(GroovyParser.ModifierContext ctx)` | Visit a parse tree produced by `GroovyParser.modifier()`.
    `List<ModifierNode>` | `visitModifiers​(GroovyParser.ModifiersContext ctx)` | Visit a parse tree produced by `GroovyParser.modifiers()`.
    `List<ModifierNode>` | `visitModifiersOpt​(GroovyParser.ModifiersOptContext ctx)` | Visit a parse tree produced by `GroovyParser.modifiersOpt()`.
    `BinaryExpression` | `visitMultipleAssignmentExprAlt​(GroovyParser.MultipleAssignmentExprAltContext ctx)` | Visit a parse tree produced by the `multipleAssignmentExprAlt` labeled alternative in `GroovyParser.expression()`.
    `BinaryExpression` | `visitMultiplicativeExprAlt​(GroovyParser.MultiplicativeExprAltContext ctx)` | Visit a parse tree produced by the `multiplicativeExprAlt` labeled alternative in `GroovyParser.expression()`.
    `List<MapEntryExpression>` | `visitNamedPropertyArgs​(GroovyParser.NamedPropertyArgsContext ctx)` | Visit a parse tree produced by `GroovyParser.namedPropertyArgs()`.
    `Expression` | `visitNamePart​(GroovyParser.NamePartContext ctx)` | Visit a parse tree produced by `GroovyParser.namePart()`.
    `Expression` | `visitNewPrmrAlt​(GroovyParser.NewPrmrAltContext ctx)` | Visit a parse tree produced by the `newPrmrAlt` labeled alternative in `GroovyParser.primary()`.
    `GenericsType[]` | `visitNonWildcardTypeArguments​(GroovyParser.NonWildcardTypeArgumentsContext ctx)` | Visit a parse tree produced by `GroovyParser.nonWildcardTypeArguments()`.
    `ConstantExpression` | `visitNullLiteralAlt​(GroovyParser.NullLiteralAltContext ctx)` | Visit a parse tree produced by the `nullLiteralAlt` labeled alternative in `GroovyParser.literal()`.
    `PackageNode` | `visitPackageDeclaration​(GroovyParser.PackageDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.packageDeclaration()`.
    `Expression` | `visitParExpression​(GroovyParser.ParExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.parExpression()`.
    `Expression` | `visitPathElement​(GroovyParser.PathElementContext ctx)` | Visit a parse tree produced by `GroovyParser.pathElement()`.
    `Expression` | `visitPathExpression​(GroovyParser.PathExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.pathExpression()`.
    `Expression` | `visitPostfixExpression​(GroovyParser.PostfixExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.postfixExpression()`.
    `BinaryExpression` | `visitPowerExprAlt​(GroovyParser.PowerExprAltContext ctx)` | Visit a parse tree produced by the `powerExprAlt` labeled alternative in `GroovyParser.expression()`.
    `ClassNode` | `visitPrimitiveType​(GroovyParser.PrimitiveTypeContext ctx)` | Visit a parse tree produced by `GroovyParser.primitiveType()`.
    `ClassNode` | `visitQualifiedClassName​(GroovyParser.QualifiedClassNameContext ctx)` | Visit a parse tree produced by `GroovyParser.qualifiedClassName()`.
    `ClassNode[]` | `visitQualifiedClassNameList​(GroovyParser.QualifiedClassNameListContext ctx)` | Visit a parse tree produced by `GroovyParser.qualifiedClassNameList()`.
    `String` | `visitQualifiedName​(GroovyParser.QualifiedNameContext ctx)` | Visit a parse tree produced by `GroovyParser.qualifiedName()`.
    `ClassNode` | `visitQualifiedStandardClassName​(GroovyParser.QualifiedStandardClassNameContext ctx)` | Visit a parse tree produced by `GroovyParser.qualifiedStandardClassName()`.
    `BinaryExpression` | `visitRegexExprAlt​(GroovyParser.RegexExprAltContext ctx)` | Visit a parse tree produced by the `regexExprAlt` labeled alternative in `GroovyParser.expression()`.
    `Expression` | `visitRelationalExprAlt​(GroovyParser.RelationalExprAltContext ctx)` | Visit a parse tree produced by the `relationalExprAlt` labeled alternative in `GroovyParser.expression()`.
    `ExpressionStatement` | `visitResource​(GroovyParser.ResourceContext ctx)` | Visit a parse tree produced by `GroovyParser.resource()`.
    `List<ExpressionStatement>` | `visitResourceList​(GroovyParser.ResourceListContext ctx)` | Visit a parse tree produced by `GroovyParser.resourceList()`.
    `List<ExpressionStatement>` | `visitResources​(GroovyParser.ResourcesContext ctx)` | Visit a parse tree produced by `GroovyParser.resources()`.
    `ReturnStatement` | `visitReturnStmtAlt​(GroovyParser.ReturnStmtAltContext ctx)` | Visit a parse tree produced by the `returnStmtAlt` labeled alternative in `GroovyParser.statement()`.
    `ClassNode` | `visitReturnType​(GroovyParser.ReturnTypeContext ctx)` | Visit a parse tree produced by `GroovyParser.returnType(int)`.
    `List<ASTNode>` | `visitScriptStatements​(GroovyParser.ScriptStatementsContext ctx)` | Visit a parse tree produced by `GroovyParser.scriptStatements()`.
    `Expression` | `visitShiftExprAlt​(GroovyParser.ShiftExprAltContext ctx)` | Visit a parse tree produced by the `shiftExprAlt` labeled alternative in `GroovyParser.expression()`.
    `LambdaExpression` | `visitStandardLambdaExpression​(GroovyParser.StandardLambdaExpressionContext ctx)` | Visit a parse tree produced by `GroovyParser.standardLambdaExpression()`.
    `Parameter[]` | `visitStandardLambdaParameters​(GroovyParser.StandardLambdaParametersContext ctx)` | Visit a parse tree produced by `GroovyParser.standardLambdaParameters()`.
    `ConstantExpression` | `visitStringLiteral​(GroovyParser.StringLiteralContext ctx)` | Visit a parse tree produced by `GroovyParser.stringLiteral()`.
    `VariableExpression` | `visitSuperPrmrAlt​(GroovyParser.SuperPrmrAltContext ctx)` | Visit a parse tree produced by the `superPrmrAlt` labeled alternative in `GroovyParser.primary()`.
    `List<Statement>` | `visitSwitchBlockStatementGroup​(GroovyParser.SwitchBlockStatementGroupContext ctx)` | Visit a parse tree produced by `GroovyParser.switchBlockStatementGroup()`.
    `Tuple2<org.antlr.v4.runtime.Token,​Expression>` | `visitSwitchLabel​(GroovyParser.SwitchLabelContext ctx)` | Visit a parse tree produced by `GroovyParser.switchLabel()`.
    `SwitchStatement` | `visitSwitchStatement​(GroovyParser.SwitchStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.switchStatement()`.
    `SynchronizedStatement` | `visitSynchronizedStmtAlt​(GroovyParser.SynchronizedStmtAltContext ctx)` | Visit a parse tree produced by the `synchronizedStmtAlt` labeled alternative in `GroovyParser.statement()`.
    `Parameter` | `visitThisFormalParameter​(GroovyParser.ThisFormalParameterContext ctx)` | Visit a parse tree produced by `GroovyParser.thisFormalParameter()`.
    `VariableExpression` | `visitThisPrmrAlt​(GroovyParser.ThisPrmrAltContext ctx)` | Visit a parse tree produced by the `thisPrmrAlt` labeled alternative in `GroovyParser.primary()`.
    `ThrowStatement` | `visitThrowStmtAlt​(GroovyParser.ThrowStmtAltContext ctx)` | Visit a parse tree produced by the `throwStmtAlt` labeled alternative in `GroovyParser.statement()`.
    `Statement` | `visitTryCatchStatement​(GroovyParser.TryCatchStatementContext ctx)` | Visit a parse tree produced by `GroovyParser.tryCatchStatement()`.
    `ClassNode` | `visitType​(GroovyParser.TypeContext ctx)` | Visit a parse tree produced by `GroovyParser.type()`.
    `GenericsType` | `visitTypeArgument​(GroovyParser.TypeArgumentContext ctx)` | Visit a parse tree produced by `GroovyParser.typeArgument()`.
    `GenericsType[]` | `visitTypeArguments​(GroovyParser.TypeArgumentsContext ctx)` | Visit a parse tree produced by `GroovyParser.typeArguments()`.
    `GenericsType[]` | `visitTypeArgumentsOrDiamond​(GroovyParser.TypeArgumentsOrDiamondContext ctx)` | Visit a parse tree produced by `GroovyParser.typeArgumentsOrDiamond()`.
    `ClassNode[]` | `visitTypeBound​(GroovyParser.TypeBoundContext ctx)` | Visit a parse tree produced by `GroovyParser.typeBound()`.
    `ClassNode` | `visitTypeDeclaration​(GroovyParser.TypeDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.typeDeclaration()`.
    `ClassNode[]` | `visitTypeList​(GroovyParser.TypeListContext ctx)` | Visit a parse tree produced by `GroovyParser.typeList()`.
    `VariableExpression` | `visitTypeNamePair​(GroovyParser.TypeNamePairContext ctx)` | Visit a parse tree produced by `GroovyParser.typeNamePair()`.
    `List<Expression>` | `visitTypeNamePairs​(GroovyParser.TypeNamePairsContext ctx)` | Visit a parse tree produced by `GroovyParser.typeNamePairs()`.
    `GenericsType` | `visitTypeParameter​(GroovyParser.TypeParameterContext ctx)` | Visit a parse tree produced by `GroovyParser.typeParameter()`.
    `GenericsType[]` | `visitTypeParameters​(GroovyParser.TypeParametersContext ctx)` | Visit a parse tree produced by `GroovyParser.typeParameters()`.
    `Expression` | `visitUnaryAddExprAlt​(GroovyParser.UnaryAddExprAltContext ctx)` | Visit a parse tree produced by the `unaryAddExprAlt` labeled alternative in `GroovyParser.castOperandExpression()`.
    `Expression` | `visitUnaryNotExprAlt​(GroovyParser.UnaryNotExprAltContext ctx)` | Visit a parse tree produced by the `unaryNotExprAlt` labeled alternative in `GroovyParser.castOperandExpression()`.
    `org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement` | `visitVariableDeclaration​(GroovyParser.VariableDeclarationContext ctx)` | Visit a parse tree produced by `GroovyParser.variableDeclaration(int)`.
    `DeclarationExpression` | `visitVariableDeclarator​(GroovyParser.VariableDeclaratorContext ctx)` | Visit a parse tree produced by `GroovyParser.variableDeclarator()`.
    `VariableExpression` | `visitVariableDeclaratorId​(GroovyParser.VariableDeclaratorIdContext ctx)` | Visit a parse tree produced by `GroovyParser.variableDeclaratorId()`.
    `List<DeclarationExpression>` | `visitVariableDeclarators​(GroovyParser.VariableDeclaratorsContext ctx)` | Visit a parse tree produced by `GroovyParser.variableDeclarators()`.
    `Expression` | `visitVariableInitializer​(GroovyParser.VariableInitializerContext ctx)` | Visit a parse tree produced by `GroovyParser.variableInitializer()`.
    `List<Expression>` | `visitVariableInitializers​(GroovyParser.VariableInitializersContext ctx)` | Visit a parse tree produced by `GroovyParser.variableInitializers()`.
    `ModifierNode` | `visitVariableModifier​(GroovyParser.VariableModifierContext ctx)` | Visit a parse tree produced by `GroovyParser.variableModifier()`.
    `List<ModifierNode>` | `visitVariableModifiers​(GroovyParser.VariableModifiersContext ctx)` | Visit a parse tree produced by `GroovyParser.variableModifiers()`.
    `List<ModifierNode>` | `visitVariableModifiersOpt​(GroovyParser.VariableModifiersOptContext ctx)` | Visit a parse tree produced by `GroovyParser.variableModifiersOpt()`.
    `TupleExpression` | `visitVariableNames​(GroovyParser.VariableNamesContext ctx)` | Visit a parse tree produced by `GroovyParser.variableNames()`.
    `WhileStatement` | `visitWhileStmtAlt​(GroovyParser.WhileStmtAltContext ctx)` | Visit a parse tree produced by the `whileStmtAlt` labeled alternative in `GroovyParser.loopStatement()`.

    - ### Methods inherited from class org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor

      `visitAssertStmtAlt, visitBlockStmtAlt, visitBreakStmtAlt, visitBuiltInTypePrmrAlt, visitClosureOrLambdaExpressionPrmrAlt, visitConditionalStmtAlt, visitContinueStmtAlt, visitElementValuePairName, visitEmptyStmtAlt, visitExpression, visitExpressionStmtAlt, visitGstringPrmrAlt, visitListPrmrAlt, visitLiteral, visitLiteralPrmrAlt, visitLocalVariableDeclarationStmtAlt, visitLoopStatement, visitMapPrmrAlt, visitMethodDeclarationStmtAlt, visitNls, visitParenPrmrAlt, visitPostfixExprAlt, visitPrimary, visitQualifiedNameElement, visitQualifiedNameElements, visitRparen, visitScriptStatement, visitSep, visitStatement, visitStatementExpression, visitStringLiteralAlt, visitTryCatchStmtAlt`

    - ### Methods inherited from class org.antlr.v4.runtime.tree.AbstractParseTreeVisitor

      `aggregateResult, defaultResult, shouldVisitNextChild, visitChildren, visitErrorNode, visitTerminal`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.antlr.v4.runtime.tree.ParseTreeVisitor

      `visitChildren, visitErrorNode, visitTerminal`

- - ### Constructor Detail

    - #### AstBuilder

          public AstBuilder​(SourceUnit sourceUnit,
                            boolean groovydocEnabled,
                            boolean runtimeGroovydocEnabled)

  - ### Method Detail

    - #### buildAST

          public ModuleNode buildAST()

    - #### visitCompilationUnit

          public ModuleNode visitCompilationUnit​(GroovyParser.CompilationUnitContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.compilationUnit()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCompilationUnit` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCompilationUnit` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitScriptStatements

          public List<ASTNode> visitScriptStatements​(GroovyParser.ScriptStatementsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.scriptStatements()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitScriptStatements` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitScriptStatements` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitPackageDeclaration

          public PackageNode visitPackageDeclaration​(GroovyParser.PackageDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.packageDeclaration()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitPackageDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitPackageDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitImportDeclaration

          public ImportNode visitImportDeclaration​(GroovyParser.ImportDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.importDeclaration()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitImportDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitImportDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAssertStatement

          public AssertStatement visitAssertStatement​(GroovyParser.AssertStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.assertStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAssertStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAssertStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitConditionalStatement

          public Statement visitConditionalStatement​(GroovyParser.ConditionalStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.conditionalStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitConditionalStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitConditionalStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitIfElseStatement

          public IfStatement visitIfElseStatement​(GroovyParser.IfElseStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.ifElseStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitIfElseStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitIfElseStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitLoopStmtAlt

          public Statement visitLoopStmtAlt​(GroovyParser.LoopStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `loopStmtAlt` labeled alternative in `GroovyParser.statement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitLoopStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitLoopStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitForStmtAlt

          public ForStatement visitForStmtAlt​(GroovyParser.ForStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `forStmtAlt` labeled alternative in `GroovyParser.loopStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitForStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitForStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitForControl

          public Tuple2<Parameter,​Expression> visitForControl​(GroovyParser.ForControlContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.forControl()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitForControl` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitForControl` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitForInit

          public Expression visitForInit​(GroovyParser.ForInitContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.forInit()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitForInit` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitForInit` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitForUpdate

          public Expression visitForUpdate​(GroovyParser.ForUpdateContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.forUpdate()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitForUpdate` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitForUpdate` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEnhancedForControl

          public Tuple2<Parameter,​Expression> visitEnhancedForControl​(GroovyParser.EnhancedForControlContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.enhancedForControl()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEnhancedForControl` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEnhancedForControl` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassicalForControl

          public Tuple2<Parameter,​Expression> visitClassicalForControl​(GroovyParser.ClassicalForControlContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classicalForControl()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassicalForControl` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassicalForControl` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitWhileStmtAlt

          public WhileStatement visitWhileStmtAlt​(GroovyParser.WhileStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `whileStmtAlt` labeled alternative in `GroovyParser.loopStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitWhileStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitWhileStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitDoWhileStmtAlt

          public DoWhileStatement visitDoWhileStmtAlt​(GroovyParser.DoWhileStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `doWhileStmtAlt` labeled alternative in `GroovyParser.loopStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitDoWhileStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitDoWhileStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTryCatchStatement

          public Statement visitTryCatchStatement​(GroovyParser.TryCatchStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.tryCatchStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTryCatchStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTryCatchStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitResources

          public List<ExpressionStatement> visitResources​(GroovyParser.ResourcesContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.resources()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitResources` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitResources` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitResourceList

          public List<ExpressionStatement> visitResourceList​(GroovyParser.ResourceListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.resourceList()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitResourceList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitResourceList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitResource

          public ExpressionStatement visitResource​(GroovyParser.ResourceContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.resource()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitResource` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitResource` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCatchClause

          public List<CatchStatement> visitCatchClause​(GroovyParser.CatchClauseContext ctx)

      Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List
      Specified by:
        `visitCatchClause` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCatchClause` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        a list of CatchStatement instances

    - #### visitCatchType

          public List<ClassNode> visitCatchType​(GroovyParser.CatchTypeContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.catchType()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCatchType` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCatchType` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitFinallyBlock

          public Statement visitFinallyBlock​(GroovyParser.FinallyBlockContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.finallyBlock()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitFinallyBlock` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitFinallyBlock` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitSwitchStatement

          public SwitchStatement visitSwitchStatement​(GroovyParser.SwitchStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.switchStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitSwitchStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitSwitchStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitSwitchBlockStatementGroup

          public List<Statement> visitSwitchBlockStatementGroup​(GroovyParser.SwitchBlockStatementGroupContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.switchBlockStatementGroup()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitSwitchBlockStatementGroup` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitSwitchBlockStatementGroup` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitSwitchLabel

          public Tuple2<org.antlr.v4.runtime.Token,​Expression> visitSwitchLabel​(GroovyParser.SwitchLabelContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.switchLabel()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitSwitchLabel` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitSwitchLabel` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitSynchronizedStmtAlt

          public SynchronizedStatement visitSynchronizedStmtAlt​(GroovyParser.SynchronizedStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `synchronizedStmtAlt` labeled alternative in `GroovyParser.statement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitSynchronizedStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitSynchronizedStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitReturnStmtAlt

          public ReturnStatement visitReturnStmtAlt​(GroovyParser.ReturnStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `returnStmtAlt` labeled alternative in `GroovyParser.statement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitReturnStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitReturnStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitThrowStmtAlt

          public ThrowStatement visitThrowStmtAlt​(GroovyParser.ThrowStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `throwStmtAlt` labeled alternative in `GroovyParser.statement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitThrowStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitThrowStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitLabeledStmtAlt

          public Statement visitLabeledStmtAlt​(GroovyParser.LabeledStmtAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `labeledStmtAlt` labeled alternative in `GroovyParser.statement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitLabeledStmtAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitLabeledStmtAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBreakStatement

          public BreakStatement visitBreakStatement​(GroovyParser.BreakStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.breakStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBreakStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBreakStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitContinueStatement

          public ContinueStatement visitContinueStatement​(GroovyParser.ContinueStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.continueStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitContinueStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitContinueStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeDeclaration

          public ClassNode visitTypeDeclaration​(GroovyParser.TypeDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeDeclaration()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassDeclaration

          public ClassNode visitClassDeclaration​(GroovyParser.ClassDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classDeclaration()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassBody

          public Void visitClassBody​(GroovyParser.ClassBodyContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classBody(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassBody` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassBody` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEnumConstants

          public List<FieldNode> visitEnumConstants​(GroovyParser.EnumConstantsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.enumConstants()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEnumConstants` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEnumConstants` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEnumConstant

          public FieldNode visitEnumConstant​(GroovyParser.EnumConstantContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.enumConstant()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEnumConstant` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEnumConstant` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassBodyDeclaration

          public Void visitClassBodyDeclaration​(GroovyParser.ClassBodyDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classBodyDeclaration(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassBodyDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassBodyDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMemberDeclaration

          public Void visitMemberDeclaration​(GroovyParser.MemberDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.memberDeclaration(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMemberDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMemberDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeParameters

          public GenericsType[] visitTypeParameters​(GroovyParser.TypeParametersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeParameters()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeParameters` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeParameters` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeParameter

          public GenericsType visitTypeParameter​(GroovyParser.TypeParameterContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeParameter()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeParameter` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeParameter` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeBound

          public ClassNode[] visitTypeBound​(GroovyParser.TypeBoundContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeBound()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeBound` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeBound` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitFieldDeclaration

          public Void visitFieldDeclaration​(GroovyParser.FieldDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.fieldDeclaration()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitFieldDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitFieldDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMethodDeclaration

          public MethodNode visitMethodDeclaration​(GroovyParser.MethodDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.methodDeclaration(int, int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMethodDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMethodDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMethodName

          public String visitMethodName​(GroovyParser.MethodNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.methodName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMethodName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMethodName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitReturnType

          public ClassNode visitReturnType​(GroovyParser.ReturnTypeContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.returnType(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitReturnType` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitReturnType` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMethodBody

          public Statement visitMethodBody​(GroovyParser.MethodBodyContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.methodBody()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMethodBody` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMethodBody` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitLocalVariableDeclaration

          public org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement visitLocalVariableDeclaration​(GroovyParser.LocalVariableDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.localVariableDeclaration()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitLocalVariableDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitLocalVariableDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassifiedModifiers

          public List<ModifierNode> visitClassifiedModifiers​(GroovyParser.ClassifiedModifiersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classifiedModifiers(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassifiedModifiers` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassifiedModifiers` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableDeclaration

          public org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement visitVariableDeclaration​(GroovyParser.VariableDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableDeclaration(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeNamePairs

          public List<Expression> visitTypeNamePairs​(GroovyParser.TypeNamePairsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeNamePairs()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeNamePairs` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeNamePairs` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeNamePair

          public VariableExpression visitTypeNamePair​(GroovyParser.TypeNamePairContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeNamePair()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeNamePair` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeNamePair` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableDeclarators

          public List<DeclarationExpression> visitVariableDeclarators​(GroovyParser.VariableDeclaratorsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableDeclarators()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableDeclarators` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableDeclarators` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableDeclarator

          public DeclarationExpression visitVariableDeclarator​(GroovyParser.VariableDeclaratorContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableDeclarator()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableDeclarator` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableDeclarator` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableInitializer

          public Expression visitVariableInitializer​(GroovyParser.VariableInitializerContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableInitializer()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableInitializer` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableInitializer` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableInitializers

          public List<Expression> visitVariableInitializers​(GroovyParser.VariableInitializersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableInitializers()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableInitializers` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableInitializers` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitArrayInitializer

          public List<Expression> visitArrayInitializer​(GroovyParser.ArrayInitializerContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.arrayInitializer()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitArrayInitializer` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitArrayInitializer` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBlock

          public Statement visitBlock​(GroovyParser.BlockContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.block()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBlock` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBlock` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCommandExprAlt

          public ExpressionStatement visitCommandExprAlt​(GroovyParser.CommandExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `commandExprAlt` labeled alternative in `GroovyParser.statementExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCommandExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCommandExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCommandExpression

          public Expression visitCommandExpression​(GroovyParser.CommandExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.commandExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCommandExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCommandExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCommandArgument

          public Expression visitCommandArgument​(GroovyParser.CommandArgumentContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.commandArgument()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCommandArgument` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCommandArgument` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCastParExpression

          public ClassNode visitCastParExpression​(GroovyParser.CastParExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.castParExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCastParExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCastParExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitParExpression

          public Expression visitParExpression​(GroovyParser.ParExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.parExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitParExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitParExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitExpressionInPar

          public Expression visitExpressionInPar​(GroovyParser.ExpressionInParContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.expressionInPar()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitExpressionInPar` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitExpressionInPar` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEnhancedStatementExpression

          public Expression visitEnhancedStatementExpression​(GroovyParser.EnhancedStatementExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.enhancedStatementExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEnhancedStatementExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEnhancedStatementExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitPathExpression

          public Expression visitPathExpression​(GroovyParser.PathExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.pathExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitPathExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitPathExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitPathElement

          public Expression visitPathElement​(GroovyParser.PathElementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.pathElement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitPathElement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitPathElement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitNonWildcardTypeArguments

          public GenericsType[] visitNonWildcardTypeArguments​(GroovyParser.NonWildcardTypeArgumentsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.nonWildcardTypeArguments()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitNonWildcardTypeArguments` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitNonWildcardTypeArguments` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeList

          public ClassNode[] visitTypeList​(GroovyParser.TypeListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeList()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitArguments

          public Expression visitArguments​(GroovyParser.ArgumentsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.arguments()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitArguments` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitArguments` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEnhancedArgumentList

          public Expression visitEnhancedArgumentList​(GroovyParser.EnhancedArgumentListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.enhancedArgumentList()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEnhancedArgumentList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEnhancedArgumentList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEnhancedArgumentListElement

          public Expression visitEnhancedArgumentListElement​(GroovyParser.EnhancedArgumentListElementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.enhancedArgumentListElement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEnhancedArgumentListElement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEnhancedArgumentListElement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitStringLiteral

          public ConstantExpression visitStringLiteral​(GroovyParser.StringLiteralContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.stringLiteral()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitStringLiteral` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitStringLiteral` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitIndexPropertyArgs

          public Tuple2<org.antlr.v4.runtime.Token,​Expression> visitIndexPropertyArgs​(GroovyParser.IndexPropertyArgsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.indexPropertyArgs()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitIndexPropertyArgs` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitIndexPropertyArgs` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitNamedPropertyArgs

          public List<MapEntryExpression> visitNamedPropertyArgs​(GroovyParser.NamedPropertyArgsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.namedPropertyArgs()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitNamedPropertyArgs` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitNamedPropertyArgs` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitNamePart

          public Expression visitNamePart​(GroovyParser.NamePartContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.namePart()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitNamePart` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitNamePart` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitDynamicMemberName

          public Expression visitDynamicMemberName​(GroovyParser.DynamicMemberNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.dynamicMemberName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitDynamicMemberName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitDynamicMemberName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitPostfixExpression

          public Expression visitPostfixExpression​(GroovyParser.PostfixExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.postfixExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitPostfixExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitPostfixExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitUnaryNotExprAlt

          public Expression visitUnaryNotExprAlt​(GroovyParser.UnaryNotExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `unaryNotExprAlt` labeled alternative in `GroovyParser.castOperandExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitUnaryNotExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitUnaryNotExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCastExprAlt

          public CastExpression visitCastExprAlt​(GroovyParser.CastExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `castExprAlt` labeled alternative in `GroovyParser.castOperandExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCastExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCastExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitPowerExprAlt

          public BinaryExpression visitPowerExprAlt​(GroovyParser.PowerExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `powerExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitPowerExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitPowerExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitUnaryAddExprAlt

          public Expression visitUnaryAddExprAlt​(GroovyParser.UnaryAddExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `unaryAddExprAlt` labeled alternative in `GroovyParser.castOperandExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitUnaryAddExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitUnaryAddExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMultiplicativeExprAlt

          public BinaryExpression visitMultiplicativeExprAlt​(GroovyParser.MultiplicativeExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `multiplicativeExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMultiplicativeExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMultiplicativeExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAdditiveExprAlt

          public BinaryExpression visitAdditiveExprAlt​(GroovyParser.AdditiveExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `additiveExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAdditiveExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAdditiveExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitShiftExprAlt

          public Expression visitShiftExprAlt​(GroovyParser.ShiftExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `shiftExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitShiftExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitShiftExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitRelationalExprAlt

          public Expression visitRelationalExprAlt​(GroovyParser.RelationalExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `relationalExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitRelationalExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitRelationalExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEqualityExprAlt

          public BinaryExpression visitEqualityExprAlt​(GroovyParser.EqualityExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `equalityExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEqualityExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEqualityExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitRegexExprAlt

          public BinaryExpression visitRegexExprAlt​(GroovyParser.RegexExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `regexExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitRegexExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitRegexExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAndExprAlt

          public BinaryExpression visitAndExprAlt​(GroovyParser.AndExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `andExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAndExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAndExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitExclusiveOrExprAlt

          public BinaryExpression visitExclusiveOrExprAlt​(GroovyParser.ExclusiveOrExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `exclusiveOrExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitExclusiveOrExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitExclusiveOrExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitInclusiveOrExprAlt

          public BinaryExpression visitInclusiveOrExprAlt​(GroovyParser.InclusiveOrExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `inclusiveOrExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitInclusiveOrExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitInclusiveOrExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitLogicalAndExprAlt

          public BinaryExpression visitLogicalAndExprAlt​(GroovyParser.LogicalAndExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `logicalAndExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitLogicalAndExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitLogicalAndExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitLogicalOrExprAlt

          public BinaryExpression visitLogicalOrExprAlt​(GroovyParser.LogicalOrExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `logicalOrExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitLogicalOrExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitLogicalOrExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitConditionalExprAlt

          public Expression visitConditionalExprAlt​(GroovyParser.ConditionalExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `conditionalExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitConditionalExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitConditionalExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMultipleAssignmentExprAlt

          public BinaryExpression visitMultipleAssignmentExprAlt​(GroovyParser.MultipleAssignmentExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `multipleAssignmentExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMultipleAssignmentExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMultipleAssignmentExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAssignmentExprAlt

          public BinaryExpression visitAssignmentExprAlt​(GroovyParser.AssignmentExprAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `assignmentExprAlt` labeled alternative in `GroovyParser.expression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAssignmentExprAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAssignmentExprAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitIdentifierPrmrAlt

          public Expression visitIdentifierPrmrAlt​(GroovyParser.IdentifierPrmrAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `identifierPrmrAlt` labeled alternative in `GroovyParser.primary()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitIdentifierPrmrAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitIdentifierPrmrAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitNewPrmrAlt

          public Expression visitNewPrmrAlt​(GroovyParser.NewPrmrAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `newPrmrAlt` labeled alternative in `GroovyParser.primary()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitNewPrmrAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitNewPrmrAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitThisPrmrAlt

          public VariableExpression visitThisPrmrAlt​(GroovyParser.ThisPrmrAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `thisPrmrAlt` labeled alternative in `GroovyParser.primary()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitThisPrmrAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitThisPrmrAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitSuperPrmrAlt

          public VariableExpression visitSuperPrmrAlt​(GroovyParser.SuperPrmrAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `superPrmrAlt` labeled alternative in `GroovyParser.primary()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitSuperPrmrAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitSuperPrmrAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCreator

          public Expression visitCreator​(GroovyParser.CreatorContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.creator(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCreator` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCreator` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitDim

          public Tuple3<Expression,​List<AnnotationNode>,​org.antlr.v4.runtime.tree.TerminalNode> visitDim​(GroovyParser.DimContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.dim()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitDim` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitDim` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAnonymousInnerClassDeclaration

          public InnerClassNode visitAnonymousInnerClassDeclaration​(GroovyParser.AnonymousInnerClassDeclarationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.anonymousInnerClassDeclaration(int)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAnonymousInnerClassDeclaration` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAnonymousInnerClassDeclaration` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitCreatedName

          public ClassNode visitCreatedName​(GroovyParser.CreatedNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.createdName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitCreatedName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitCreatedName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMap

          public MapExpression visitMap​(GroovyParser.MapContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.map()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMap` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMap` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMapEntryList

          public List<MapEntryExpression> visitMapEntryList​(GroovyParser.MapEntryListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.mapEntryList()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMapEntryList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMapEntryList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMapEntry

          public MapEntryExpression visitMapEntry​(GroovyParser.MapEntryContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.mapEntry()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMapEntry` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMapEntry` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitMapEntryLabel

          public Expression visitMapEntryLabel​(GroovyParser.MapEntryLabelContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.mapEntryLabel()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitMapEntryLabel` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitMapEntryLabel` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitKeywords

          public ConstantExpression visitKeywords​(GroovyParser.KeywordsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.keywords()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitKeywords` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitKeywords` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBuiltInType

          public VariableExpression visitBuiltInType​(GroovyParser.BuiltInTypeContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.builtInType()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBuiltInType` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBuiltInType` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitList

          public ListExpression visitList​(GroovyParser.ListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.list()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitExpressionList

          public List<Expression> visitExpressionList​(GroovyParser.ExpressionListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.expressionList(boolean)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitExpressionList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitExpressionList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitExpressionListElement

          public Expression visitExpressionListElement​(GroovyParser.ExpressionListElementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.expressionListElement(boolean)`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitExpressionListElement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitExpressionListElement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitIntegerLiteralAlt

          public ConstantExpression visitIntegerLiteralAlt​(GroovyParser.IntegerLiteralAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `integerLiteralAlt` labeled alternative in `GroovyParser.literal()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitIntegerLiteralAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitIntegerLiteralAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitFloatingPointLiteralAlt

          public ConstantExpression visitFloatingPointLiteralAlt​(GroovyParser.FloatingPointLiteralAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `floatingPointLiteralAlt` labeled alternative in `GroovyParser.literal()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitFloatingPointLiteralAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitFloatingPointLiteralAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBooleanLiteralAlt

          public ConstantExpression visitBooleanLiteralAlt​(GroovyParser.BooleanLiteralAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `booleanLiteralAlt` labeled alternative in `GroovyParser.literal()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBooleanLiteralAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBooleanLiteralAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitNullLiteralAlt

          public ConstantExpression visitNullLiteralAlt​(GroovyParser.NullLiteralAltContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by the `nullLiteralAlt` labeled alternative in `GroovyParser.literal()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitNullLiteralAlt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitNullLiteralAlt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitGstring

          public GStringExpression visitGstring​(GroovyParser.GstringContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.gstring()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitGstring` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitGstring` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitGstringValue

          public Expression visitGstringValue​(GroovyParser.GstringValueContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.gstringValue()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitGstringValue` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitGstringValue` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitGstringPath

          public Expression visitGstringPath​(GroovyParser.GstringPathContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.gstringPath()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitGstringPath` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitGstringPath` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitStandardLambdaExpression

          public LambdaExpression visitStandardLambdaExpression​(GroovyParser.StandardLambdaExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.standardLambdaExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitStandardLambdaExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitStandardLambdaExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitStandardLambdaParameters

          public Parameter[] visitStandardLambdaParameters​(GroovyParser.StandardLambdaParametersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.standardLambdaParameters()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitStandardLambdaParameters` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitStandardLambdaParameters` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitLambdaBody

          public Statement visitLambdaBody​(GroovyParser.LambdaBodyContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.lambdaBody()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitLambdaBody` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitLambdaBody` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClosure

          public ClosureExpression visitClosure​(GroovyParser.ClosureContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.closure()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClosure` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClosure` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitFormalParameters

          public Parameter[] visitFormalParameters​(GroovyParser.FormalParametersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.formalParameters()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitFormalParameters` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitFormalParameters` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitFormalParameterList

          public Parameter[] visitFormalParameterList​(GroovyParser.FormalParameterListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.formalParameterList()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitFormalParameterList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitFormalParameterList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitFormalParameter

          public Parameter visitFormalParameter​(GroovyParser.FormalParameterContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.formalParameter()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitFormalParameter` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitFormalParameter` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitThisFormalParameter

          public Parameter visitThisFormalParameter​(GroovyParser.ThisFormalParameterContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.thisFormalParameter()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitThisFormalParameter` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitThisFormalParameter` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassOrInterfaceModifiersOpt

          public List<ModifierNode> visitClassOrInterfaceModifiersOpt​(GroovyParser.ClassOrInterfaceModifiersOptContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classOrInterfaceModifiersOpt()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassOrInterfaceModifiersOpt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassOrInterfaceModifiersOpt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassOrInterfaceModifiers

          public List<ModifierNode> visitClassOrInterfaceModifiers​(GroovyParser.ClassOrInterfaceModifiersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classOrInterfaceModifiers()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassOrInterfaceModifiers` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassOrInterfaceModifiers` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassOrInterfaceModifier

          public ModifierNode visitClassOrInterfaceModifier​(GroovyParser.ClassOrInterfaceModifierContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classOrInterfaceModifier()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassOrInterfaceModifier` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassOrInterfaceModifier` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitModifier

          public ModifierNode visitModifier​(GroovyParser.ModifierContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.modifier()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitModifier` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitModifier` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitModifiers

          public List<ModifierNode> visitModifiers​(GroovyParser.ModifiersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.modifiers()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitModifiers` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitModifiers` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitModifiersOpt

          public List<ModifierNode> visitModifiersOpt​(GroovyParser.ModifiersOptContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.modifiersOpt()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitModifiersOpt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitModifiersOpt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableModifier

          public ModifierNode visitVariableModifier​(GroovyParser.VariableModifierContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableModifier()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableModifier` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableModifier` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableModifiersOpt

          public List<ModifierNode> visitVariableModifiersOpt​(GroovyParser.VariableModifiersOptContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableModifiersOpt()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableModifiersOpt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableModifiersOpt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableModifiers

          public List<ModifierNode> visitVariableModifiers​(GroovyParser.VariableModifiersContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableModifiers()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableModifiers` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableModifiers` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEmptyDims

          public List<List<AnnotationNode>> visitEmptyDims​(GroovyParser.EmptyDimsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.emptyDims()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEmptyDims` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEmptyDims` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitEmptyDimsOpt

          public List<List<AnnotationNode>> visitEmptyDimsOpt​(GroovyParser.EmptyDimsOptContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.emptyDimsOpt()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitEmptyDimsOpt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitEmptyDimsOpt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitType

          public ClassNode visitType​(GroovyParser.TypeContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.type()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitType` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitType` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassOrInterfaceType

          public ClassNode visitClassOrInterfaceType​(GroovyParser.ClassOrInterfaceTypeContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.classOrInterfaceType()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassOrInterfaceType` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassOrInterfaceType` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeArgumentsOrDiamond

          public GenericsType[] visitTypeArgumentsOrDiamond​(GroovyParser.TypeArgumentsOrDiamondContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeArgumentsOrDiamond()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeArgumentsOrDiamond` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeArgumentsOrDiamond` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeArguments

          public GenericsType[] visitTypeArguments​(GroovyParser.TypeArgumentsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeArguments()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeArguments` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeArguments` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitTypeArgument

          public GenericsType visitTypeArgument​(GroovyParser.TypeArgumentContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.typeArgument()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitTypeArgument` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitTypeArgument` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitPrimitiveType

          public ClassNode visitPrimitiveType​(GroovyParser.PrimitiveTypeContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.primitiveType()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitPrimitiveType` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitPrimitiveType` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableDeclaratorId

          public VariableExpression visitVariableDeclaratorId​(GroovyParser.VariableDeclaratorIdContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableDeclaratorId()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableDeclaratorId` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableDeclaratorId` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitVariableNames

          public TupleExpression visitVariableNames​(GroovyParser.VariableNamesContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.variableNames()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitVariableNames` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitVariableNames` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClosureOrLambdaExpression

          public ClosureExpression visitClosureOrLambdaExpression​(GroovyParser.ClosureOrLambdaExpressionContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.closureOrLambdaExpression()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClosureOrLambdaExpression` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClosureOrLambdaExpression` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBlockStatementsOpt

          public BlockStatement visitBlockStatementsOpt​(GroovyParser.BlockStatementsOptContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.blockStatementsOpt()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBlockStatementsOpt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBlockStatementsOpt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBlockStatements

          public BlockStatement visitBlockStatements​(GroovyParser.BlockStatementsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.blockStatements()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBlockStatements` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBlockStatements` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitBlockStatement

          public Statement visitBlockStatement​(GroovyParser.BlockStatementContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.blockStatement()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitBlockStatement` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitBlockStatement` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAnnotationsOpt

          public List<AnnotationNode> visitAnnotationsOpt​(GroovyParser.AnnotationsOptContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.annotationsOpt()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAnnotationsOpt` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAnnotationsOpt` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAnnotation

          public AnnotationNode visitAnnotation​(GroovyParser.AnnotationContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.annotation()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAnnotation` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAnnotation` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitElementValues

          public List<Tuple2<String,​Expression>> visitElementValues​(GroovyParser.ElementValuesContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.elementValues()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitElementValues` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitElementValues` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAnnotationName

          public String visitAnnotationName​(GroovyParser.AnnotationNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.annotationName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAnnotationName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAnnotationName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitElementValuePairs

          public Map<String,​Expression> visitElementValuePairs​(GroovyParser.ElementValuePairsContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.elementValuePairs()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitElementValuePairs` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitElementValuePairs` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitElementValuePair

          public Tuple2<String,​Expression> visitElementValuePair​(GroovyParser.ElementValuePairContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.elementValuePair()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitElementValuePair` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitElementValuePair` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitElementValue

          public Expression visitElementValue​(GroovyParser.ElementValueContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.elementValue()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitElementValue` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitElementValue` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitElementValueArrayInitializer

          public ListExpression visitElementValueArrayInitializer​(GroovyParser.ElementValueArrayInitializerContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.elementValueArrayInitializer()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitElementValueArrayInitializer` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitElementValueArrayInitializer` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitClassName

          public String visitClassName​(GroovyParser.ClassNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.className()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitClassName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitClassName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitIdentifier

          public String visitIdentifier​(GroovyParser.IdentifierContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.identifier()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitIdentifier` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitIdentifier` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitQualifiedName

          public String visitQualifiedName​(GroovyParser.QualifiedNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.qualifiedName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitQualifiedName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitQualifiedName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitAnnotatedQualifiedClassName

          public ClassNode visitAnnotatedQualifiedClassName​(GroovyParser.AnnotatedQualifiedClassNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.annotatedQualifiedClassName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitAnnotatedQualifiedClassName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitAnnotatedQualifiedClassName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitQualifiedClassNameList

          public ClassNode[] visitQualifiedClassNameList​(GroovyParser.QualifiedClassNameListContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.qualifiedClassNameList()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitQualifiedClassNameList` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitQualifiedClassNameList` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitQualifiedClassName

          public ClassNode visitQualifiedClassName​(GroovyParser.QualifiedClassNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.qualifiedClassName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitQualifiedClassName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitQualifiedClassName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visitQualifiedStandardClassName

          public ClassNode visitQualifiedStandardClassName​(GroovyParser.QualifiedStandardClassNameContext ctx)

      Description copied from class: `GroovyParserBaseVisitor`
      Visit a parse tree produced by `GroovyParser.qualifiedStandardClassName()`.

      The default implementation returns the result of calling `AbstractParseTreeVisitor.visitChildren(org.antlr.v4.runtime.tree.RuleNode)` on `ctx`.

      Specified by:
        `visitQualifiedStandardClassName` in interface `GroovyParserVisitor<Object>`
      Overrides:
        `visitQualifiedStandardClassName` in class `GroovyParserBaseVisitor<Object>`
      Parameters:
        `ctx` - the parse tree
      Returns:
        the visitor result

    - #### visit

          public Object visit​(org.antlr.v4.runtime.tree.ParseTree tree)

      Visit tree safely, no NPE occurred when the tree is null.
      Specified by:
        `visit` in interface `org.antlr.v4.runtime.tree.ParseTreeVisitor<Object>`
      Overrides:
        `visit` in class `org.antlr.v4.runtime.tree.AbstractParseTreeVisitor<Object>`
      Parameters:
        `tree` - an AST node
      Returns:
        the visiting result

    - #### appendStatementsToBlockStatement

          public BlockStatement appendStatementsToBlockStatement​(BlockStatement bs,
                                                                 Statement... statements)